/**
 * GIK (Great Invention Kit, or Grace Gershenfeld's Invention Kit) 
 * Module Maker
 * Inspired from GIK on Wikipedia
 * http://en.wikipedia.org/wiki/GIK 
 **/
 
 
 //For Processing 0133 Beta
 
import controlP5.*;
import processing.dxf.*;
import processing.pdf.*;

ControlP5 controlP5;

float narrow_thickness = 2.34375;
float wide_thickness = 2.35375*2; 
float edge = 50;
boolean record = true;

//rectangles
float ax = 100; float aax = 200; float aaax = 300; float aaaax = 400; float aaaaax = 500; float aaaaaax = 600;
float ay = 120; float aay = 120; float aaay = 120; float aaaay = 120; float aaaaay = 120; float aaaaaay = 120;

float bx = 100; float bbx = 200; float bbbx = 300; float bbbbx = 400; float bbbbbx = 500; float bbbbbbx = 600;
float by = 220; float bby = 220; float bbby = 220; float bbbby = 220; float bbbbby = 220; float bbbbbby = 220;

float cx = 100; float ccx = 200; float cccx = 300; float ccccx = 400; float cccccx = 500; float ccccccx = 600;
float cy = 240; float ccy = 240; float cccy = 240; float ccccy = 240; float cccccy = 240; float ccccccy = 240;

float dx = 100; float ddx = 200; float dddx = 300; float ddddx = 400; float dddddx = 500; float ddddddx = 600;
float dy = 240; float ddy = 240; float dddy = 240; float ddddy = 240; float dddddy = 240; float ddddddy = 240;

//circles
float ex = 100; float eex = 200; float eeex = 300; float eeeex = 400; float eeeeex = 500; float eeeeeex = 600;
float ey = 320; float eey = 320; float eeey = 320; float eeeey = 320; float eeeeey = 320; float eeeeeey = 320;

float fx = 100; float ffx = 200; float fffx = 300; float ffffx = 400; float fffffx = 500; float ffffffx = 600;
float fy = 420; float ffy = 420; float fffy = 420; float ffffy = 420; float fffffy = 420; float ffffffy = 420;


//triangles

float ix = 100; float iix = 250; float iiix = 400; float iiiix = 550; float iiiiix = 700; float iiiiiix = 850;
float iy = 535; float iiy = 535; float iiiy = 535; float iiiiy = 535; float iiiiiy = 535; float iiiiiiy = 535;

float jx = 100; float jjx = 250; float jjjx = 400; float jjjjx = 550; float jjjjjx = 700; float jjjjjjx = 850;
float jy = 650; float jjy = 650; float jjjy = 650; float jjjjy = 650; float jjjjjy = 650; float jjjjjjy = 650;


 void setup() 
{ 
size(700, 750);
  controlP5 = new ControlP5(this);
  // add a vertical slider
  controlP5.addSlider("wide_thickness",0,25,2.34375,350,25,100,10);
  controlP5.addSlider("narrow_thickness",0,25,2.34375,350,40,100,10);
  controlP5.addSlider("edge",0,80,80,350,10,100,10);

}

void draw()
{
  if (record) {
    println("start");
 //      beginRecord(PDF, "Line.pdf"); 
         beginRecord(PDF, second()+"_"+minute()+"_"+hour()+"_"+day()+"_"+month()+"_"+year()+"_"+"GIK_Kit.pdf"); 
  }


  // do all your drawing here

smooth(); 
background(0);

PFont font;
// The font must be located in the sketch's 
// "data" directory to load successfully
font = loadFont("Tahoma-16.vlw"); 
textFont(font); fill(255);
text("FRACTAL-GIK-Kits Constructer Ver2.0", 25, 30); 
text("Sheet Width=650, Height=630", 350,705);
text("Press [r] to Save PDF", 350,725);

noFill();
stroke(255);

rect(25,80,650,630);

// Rectangles

// Shape-A-0
// 1/4
line(ax,ay-edge/4, ax-narrow_thickness/2, ay-edge/4);
line(ax-narrow_thickness/2, ay-edge/4, ax-narrow_thickness/2, ay-edge/2);
line(ax-narrow_thickness/2, ay-edge/2, ax-edge/2, ay-edge/2);
line(ax-edge/2, ay-edge/2, ax-edge/2, ay-narrow_thickness/2);
line(ax-edge/2, ay-narrow_thickness/2,ax-edge/4, ay-narrow_thickness/2);
line(ax-edge/4, ay-narrow_thickness/2, ax-edge/4, ay);
// 1/4
line(ax,ay+edge/4, ax-narrow_thickness/2, ay+edge/4);
line(ax-narrow_thickness/2, ay+edge/4, ax-narrow_thickness/2, ay+edge/2);
line(ax-narrow_thickness/2, ay+edge/2, ax-edge/2, ay+edge/2);
line(ax-edge/2, ay+edge/2, ax-edge/2, ay+narrow_thickness/2);
line(ax-edge/2, ay+narrow_thickness/2,ax-edge/4, ay+narrow_thickness/2);
line(ax-edge/4, ay+narrow_thickness/2, ax-edge/4, ay);
// 1/4
line(ax,ay-edge/4, ax+narrow_thickness/2, ay-edge/4);
line(ax+narrow_thickness/2, ay-edge/4, ax+narrow_thickness/2, ay-edge/2);
line(ax+narrow_thickness/2, ay-edge/2, ax+edge/2, ay-edge/2);
line(ax+edge/2, ay-edge/2, ax+edge/2, ay-narrow_thickness/2);
line(ax+edge/2, ay-narrow_thickness/2,ax+edge/4, ay-narrow_thickness/2);
line(ax+edge/4, ay-narrow_thickness/2, ax+edge/4, ay);
// 1/4
line(ax,ay+edge/4, ax+narrow_thickness/2, ay+edge/4);
line(ax+narrow_thickness/2, ay+edge/4, ax+narrow_thickness/2, ay+edge/2);
line(ax+narrow_thickness/2, ay+edge/2, ax+edge/2, ay+edge/2);
line(ax+edge/2, ay+edge/2, ax+edge/2, ay+narrow_thickness/2);
line(ax+edge/2, ay+narrow_thickness/2,ax+edge/4, ay+narrow_thickness/2);
line(ax+edge/4, ay+narrow_thickness/2, ax+edge/4, ay);


// Shape-A-1
// 1/4
line(aax,aay-edge/4, aax-wide_thickness/2, aay-edge/4);
line(aax-wide_thickness/2, aay-edge/4, aax-wide_thickness/2, aay-edge/2);
line(aax-wide_thickness/2, aay-edge/2, aax-edge/2, aay-edge/2);
line(aax-edge/2, aay-edge/2, aax-edge/2, aay-narrow_thickness/2);
line(aax-edge/2, aay-narrow_thickness/2,aax-edge/4, aay-narrow_thickness/2);
line(aax-edge/4, aay-narrow_thickness/2, aax-edge/4, aay);
// 1/4
line(aax,aay+edge/4, aax-narrow_thickness/2, aay+edge/4);
line(aax-narrow_thickness/2, aay+edge/4, aax-narrow_thickness/2, aay+edge/2);
line(aax-narrow_thickness/2, aay+edge/2, aax-edge/2, aay+edge/2);
line(aax-edge/2, aay+edge/2, aax-edge/2, aay+narrow_thickness/2);
line(aax-edge/2, aay+narrow_thickness/2,aax-edge/4, aay+narrow_thickness/2);
line(aax-edge/4, aay+narrow_thickness/2, aax-edge/4, aay);
// 1/4
line(aax,aay-edge/4, aax+wide_thickness/2, aay-edge/4);
line(aax+wide_thickness/2, aay-edge/4, aax+wide_thickness/2, aay-edge/2);
line(aax+wide_thickness/2, aay-edge/2, aax+edge/2, aay-edge/2);
line(aax+edge/2, aay-edge/2, aax+edge/2, aay-narrow_thickness/2);
line(aax+edge/2, aay-narrow_thickness/2,aax+edge/4, aay-narrow_thickness/2);
line(aax+edge/4, aay-narrow_thickness/2, aax+edge/4, aay);
// 1/4
line(aax,aay+edge/4, aax+narrow_thickness/2, aay+edge/4);
line(aax+narrow_thickness/2, aay+edge/4, aax+narrow_thickness/2, aay+edge/2);
line(aax+narrow_thickness/2, aay+edge/2, aax+edge/2, aay+edge/2);
line(aax+edge/2, aay+edge/2, aax+edge/2, aay+narrow_thickness/2);
line(aax+edge/2, aay+narrow_thickness/2,aax+edge/4, aay+narrow_thickness/2);
line(aax+edge/4, aay+narrow_thickness/2, aax+edge/4, aay);


// Shape-A-2
// 1/4
line(aaax,aaay-edge/4, aaax-wide_thickness/2, aaay-edge/4);
line(aaax-wide_thickness/2, aaay-edge/4, aaax-wide_thickness/2, aaay-edge/2);
line(aaax-wide_thickness/2, aaay-edge/2, aaax-edge/2, aaay-edge/2);
line(aaax-edge/2, aaay-edge/2, aaax-edge/2, aaay-wide_thickness/2);
line(aaax-edge/2, aaay-wide_thickness/2,aaax-edge/4, aaay-wide_thickness/2);
line(aaax-edge/4, aaay-wide_thickness/2, aaax-edge/4, aaay);
// 1/4
line(aaax,aaay+edge/4, aaax-narrow_thickness/2, aaay+edge/4);
line(aaax-narrow_thickness/2, aaay+edge/4, aaax-narrow_thickness/2, aaay+edge/2);
line(aaax-narrow_thickness/2, aaay+edge/2, aaax-edge/2, aaay+edge/2);
line(aaax-edge/2, aaay+edge/2, aaax-edge/2, aaay+wide_thickness/2);
line(aaax-edge/2, aaay+wide_thickness/2,aaax-edge/4, aaay+wide_thickness/2);
line(aaax-edge/4, aaay+wide_thickness/2, aaax-edge/4, aaay);
// 1/4
line(aaax,aaay-edge/4, aaax+wide_thickness/2, aaay-edge/4);
line(aaax+wide_thickness/2, aaay-edge/4, aaax+wide_thickness/2, aaay-edge/2);
line(aaax+wide_thickness/2, aaay-edge/2, aaax+edge/2, aaay-edge/2);
line(aaax+edge/2, aaay-edge/2, aaax+edge/2, aaay-narrow_thickness/2);
line(aaax+edge/2, aaay-narrow_thickness/2,aaax+edge/4, aaay-narrow_thickness/2);
line(aaax+edge/4, aaay-narrow_thickness/2, aaax+edge/4, aaay);
// 1/4
line(aaax,aaay+edge/4, aaax+narrow_thickness/2, aaay+edge/4);
line(aaax+narrow_thickness/2, aaay+edge/4, aaax+narrow_thickness/2, aaay+edge/2);
line(aaax+narrow_thickness/2, aaay+edge/2, aaax+edge/2, aaay+edge/2);
line(aaax+edge/2, aaay+edge/2, aaax+edge/2, aaay+narrow_thickness/2);
line(aaax+edge/2, aaay+narrow_thickness/2,aaax+edge/4, aaay+narrow_thickness/2);
line(aaax+edge/4, aaay+narrow_thickness/2, aaax+edge/4, aaay);

// Shape-A-3
// 1/4
line(aaaax,aaaay-edge/4, aaaax-wide_thickness/2, aaaay-edge/4);
line(aaaax-wide_thickness/2, aaaay-edge/4, aaaax-wide_thickness/2, aaaay-edge/2);
line(aaaax-wide_thickness/2, aaaay-edge/2, aaaax-edge/2, aaaay-edge/2);
line(aaaax-edge/2, aaaay-edge/2, aaaax-edge/2, aaaay-wide_thickness/2);
line(aaaax-edge/2, aaaay-wide_thickness/2,aaaax-edge/4, aaaay-wide_thickness/2);
line(aaaax-edge/4, aaaay-wide_thickness/2, aaaax-edge/4, aaaay);
// 1/4
line(aaaax,aaaay+edge/4, aaaax-wide_thickness/2, aaaay+edge/4);
line(aaaax-wide_thickness/2, aaaay+edge/4, aaaax-wide_thickness/2, aaaay+edge/2);
line(aaaax-wide_thickness/2, aaaay+edge/2, aaaax-edge/2, aaaay+edge/2);
line(aaaax-edge/2, aaaay+edge/2, aaaax-edge/2, aaaay+wide_thickness/2);
line(aaaax-edge/2, aaaay+wide_thickness/2,aaaax-edge/4, aaaay+wide_thickness/2);
line(aaaax-edge/4, aaaay+wide_thickness/2, aaaax-edge/4, aaaay);
// 1/4
line(aaaax,aaaay-edge/4, aaaax+wide_thickness/2, aaaay-edge/4);
line(aaaax+wide_thickness/2, aaaay-edge/4, aaaax+wide_thickness/2, aaaay-edge/2);
line(aaaax+wide_thickness/2, aaaay-edge/2, aaaax+edge/2, aaaay-edge/2);
line(aaaax+edge/2, aaaay-edge/2, aaaax+edge/2, aaaay-narrow_thickness/2);
line(aaaax+edge/2, aaaay-narrow_thickness/2, aaaax+edge/4, aaaay-narrow_thickness/2);
line(aaaax+edge/4, aaaay-narrow_thickness/2, aaaax+edge/4, aaaay);
// 1/4
line(aaaax,aaaay+edge/4, aaaax+wide_thickness/2, aaaay+edge/4);
line(aaaax+wide_thickness/2, aaaay+edge/4, aaaax+wide_thickness/2, aaaay+edge/2);
line(aaaax+wide_thickness/2, aaaay+edge/2, aaaax+edge/2, aaaay+edge/2);
line(aaaax+edge/2, aaaay+edge/2, aaaax+edge/2, aaaay+narrow_thickness/2);
line(aaaax+edge/2, aaaay+narrow_thickness/2,aaaax+edge/4, aaaay+narrow_thickness/2);
line(aaaax+edge/4, aaaay+narrow_thickness/2, aaaax+edge/4, aaaay);

// Shape-A-4
// 1/4
line(aaaaax,aaaaay-edge/4, aaaaax-wide_thickness/2, aaaaay-edge/4);
line(aaaaax-wide_thickness/2, aaaaay-edge/4, aaaaax-wide_thickness/2, aaaaay-edge/2);
line(aaaaax-wide_thickness/2, aaaaay-edge/2, aaaaax-edge/2, aaaaay-edge/2);
line(aaaaax-edge/2, aaaaay-edge/2, aaaaax-edge/2, aaaaay-narrow_thickness/2);
line(aaaaax-edge/2, aaaaay-narrow_thickness/2, aaaaax-edge/4, aaaaay-narrow_thickness/2);
line(aaaaax-edge/4, aaaaay-narrow_thickness/2, aaaaax-edge/4, aaaaay);
// 1/4
line(aaaaax,aaaaay+edge/4, aaaaax-wide_thickness/2, aaaaay+edge/4);
line(aaaaax-wide_thickness/2, aaaaay+edge/4, aaaaax-wide_thickness/2, aaaaay+edge/2);
line(aaaaax-wide_thickness/2, aaaaay+edge/2, aaaaax-edge/2, aaaaay+edge/2);
line(aaaaax-edge/2, aaaaay+edge/2, aaaaax-edge/2, aaaaay+narrow_thickness/2);
line(aaaaax-edge/2, aaaaay+narrow_thickness/2,aaaaax-edge/4, aaaaay+narrow_thickness/2);
line(aaaaax-edge/4, aaaaay+narrow_thickness/2, aaaaax-edge/4, aaaaay);
// 1/4
line(aaaaax,aaaaay-edge/4, aaaaax+wide_thickness/2, aaaaay-edge/4);
line(aaaaax+wide_thickness/2, aaaaay-edge/4, aaaaax+wide_thickness/2, aaaaay-edge/2);
line(aaaaax+wide_thickness/2, aaaaay-edge/2, aaaaax+edge/2, aaaaay-edge/2);
line(aaaaax+edge/2, aaaaay-edge/2, aaaaax+edge/2, aaaaay-narrow_thickness/2);
line(aaaaax+edge/2, aaaaay-narrow_thickness/2, aaaaax+edge/4, aaaaay-narrow_thickness/2);
line(aaaaax+edge/4, aaaaay-narrow_thickness/2, aaaaax+edge/4, aaaaay);
// 1/4
line(aaaaax,aaaaay+edge/4, aaaaax+wide_thickness/2, aaaaay+edge/4);
line(aaaaax+wide_thickness/2, aaaaay+edge/4, aaaaax+wide_thickness/2, aaaaay+edge/2);
line(aaaaax+wide_thickness/2, aaaaay+edge/2, aaaaax+edge/2, aaaaay+edge/2);
line(aaaaax+edge/2, aaaaay+edge/2, aaaaax+edge/2, aaaaay+narrow_thickness/2);
line(aaaaax+edge/2, aaaaay+narrow_thickness/2,aaaaax+edge/4, aaaaay+narrow_thickness/2);
line(aaaaax+edge/4, aaaaay+narrow_thickness/2, aaaaax+edge/4, aaaaay);

// Shape-A-5
// 1/4
line(aaaaaax,aaaaaay-edge/4, aaaaaax-wide_thickness/2, aaaaaay-edge/4);
line(aaaaaax-wide_thickness/2, aaaaaay-edge/4, aaaaaax-wide_thickness/2, aaaaaay-edge/2);
line(aaaaaax-wide_thickness/2, aaaaaay-edge/2, aaaaaax-edge/2, aaaaaay-edge/2);
line(aaaaaax-edge/2, aaaaaay-edge/2, aaaaaax-edge/2, aaaaaay-wide_thickness/2);
line(aaaaaax-edge/2, aaaaaay-wide_thickness/2, aaaaaax-edge/4, aaaaaay-wide_thickness/2);
line(aaaaaax-edge/4, aaaaaay-wide_thickness/2, aaaaaax-edge/4, aaaaaay);
// 1/4
line(aaaaaax,aaaaaay+edge/4, aaaaaax-wide_thickness/2, aaaaaay+edge/4);
line(aaaaaax-wide_thickness/2, aaaaaay+edge/4, aaaaaax-wide_thickness/2, aaaaaay+edge/2);
line(aaaaaax-wide_thickness/2, aaaaaay+edge/2, aaaaaax-edge/2, aaaaaay+edge/2);
line(aaaaaax-edge/2, aaaaaay+edge/2, aaaaaax-edge/2, aaaaaay+wide_thickness/2);
line(aaaaaax-edge/2, aaaaaay+wide_thickness/2,aaaaaax-edge/4, aaaaaay+wide_thickness/2);
line(aaaaaax-edge/4, aaaaaay+wide_thickness/2, aaaaaax-edge/4, aaaaaay);
// 1/4
line(aaaaaax,aaaaaay-edge/4, aaaaaax+wide_thickness/2, aaaaaay-edge/4);
line(aaaaaax+wide_thickness/2, aaaaaay-edge/4, aaaaaax+wide_thickness/2, aaaaaay-edge/2);
line(aaaaaax+wide_thickness/2, aaaaaay-edge/2, aaaaaax+edge/2, aaaaaay-edge/2);
line(aaaaaax+edge/2, aaaaaay-edge/2, aaaaaax+edge/2, aaaaaay-wide_thickness/2);
line(aaaaaax+edge/2, aaaaaay-wide_thickness/2, aaaaaax+edge/4, aaaaaay-wide_thickness/2);
line(aaaaaax+edge/4, aaaaaay-wide_thickness/2, aaaaaax+edge/4, aaaaaay);
// 1/4
line(aaaaaax,aaaaaay+edge/4, aaaaaax+wide_thickness/2, aaaaaay+edge/4);
line(aaaaaax+wide_thickness/2, aaaaaay+edge/4, aaaaaax+wide_thickness/2, aaaaaay+edge/2);
line(aaaaaax+wide_thickness/2, aaaaaay+edge/2, aaaaaax+edge/2, aaaaaay+edge/2);
line(aaaaaax+edge/2, aaaaaay+edge/2, aaaaaax+edge/2, aaaaaay+wide_thickness/2);
line(aaaaaax+edge/2, aaaaaay+wide_thickness/2,aaaaaax+edge/4, aaaaaay+wide_thickness/2);
line(aaaaaax+edge/4, aaaaaay+wide_thickness/2, aaaaaax+edge/4, aaaaaay);


// Shape-B
// 1/4
line(bx,by-edge/4, bx-narrow_thickness/2, by-edge/4);
line(bx-narrow_thickness/2, by-edge/4, bx-narrow_thickness/2, by-edge/2);
line(bx-narrow_thickness/2, by-edge/2, bx-edge/2, by-edge/2);
line(bx-edge/2, by-edge/2, bx-edge/2, by-narrow_thickness/2);
line(bx-edge/2, by-narrow_thickness/2, bx, by-narrow_thickness/2);
line(bx, by-narrow_thickness/2, bx, by);
// 1/4
line(bx,by+edge/4, bx-narrow_thickness/2, by+edge/4);
line(bx-narrow_thickness/2, by+edge/4, bx-narrow_thickness/2, by+edge/2);
line(bx-narrow_thickness/2, by+edge/2, bx-edge/2, by+edge/2);
line(bx-edge/2, by+edge/2, bx-edge/2, by+narrow_thickness/2);
line(bx-edge/2, by+narrow_thickness/2, bx, by+narrow_thickness/2);
line(bx, by+narrow_thickness/2, bx, by);
// 1/4
line(bx,by-edge/4, bx+narrow_thickness/2, by-edge/4);
line(bx+narrow_thickness/2, by-edge/4, bx+narrow_thickness/2, by-edge/2);
line(bx+narrow_thickness/2, by-edge/2, bx+edge/2, by-edge/2);
line(bx+edge/2, by-edge/2, bx+edge/2, by-narrow_thickness/2);
line(bx+edge/2, by-narrow_thickness/2, bx+edge/4, by-narrow_thickness/2);
line(bx+edge/4, by-narrow_thickness/2, bx+edge/4, by);
// 1/4
line(bx,by+edge/4, bx+narrow_thickness/2, by+edge/4);
line(bx+narrow_thickness/2, by+edge/4, bx+narrow_thickness/2, by+edge/2);
line(bx+narrow_thickness/2, by+edge/2, bx+edge/2, by+edge/2);
line(bx+edge/2, by+edge/2, bx+edge/2, by+narrow_thickness/2);
line(bx+edge/2, by+narrow_thickness/2,bx+edge/4, by+narrow_thickness/2);
line(bx+edge/4, by+narrow_thickness/2, bx+edge/4, by);


// Shape-B-2
// 1/4
line(bbx,bby-edge/4, bbx-narrow_thickness/2, bby-edge/4);
line(bbx-narrow_thickness/2, bby-edge/4, bbx-narrow_thickness/2, bby-edge/2);
line(bbx-narrow_thickness/2, bby-edge/2, bbx-edge/2, bby-edge/2);
line(bbx-edge/2, bby-edge/2, bbx-edge/2, bby-wide_thickness/2);
line(bbx-edge/2, bby-wide_thickness/2, bbx, bby-wide_thickness/2);
line(bbx, bby-wide_thickness/2, bbx, bby);
// 1/4
line(bbx,bby+edge/4, bbx-narrow_thickness/2, bby+edge/4);
line(bbx-narrow_thickness/2, bby+edge/4, bbx-narrow_thickness/2, bby+edge/2);
line(bbx-narrow_thickness/2, bby+edge/2, bbx-edge/2, bby+edge/2);
line(bbx-edge/2, bby+edge/2, bbx-edge/2, bby+wide_thickness/2);
line(bbx-edge/2, bby+wide_thickness/2, bbx, bby+wide_thickness/2);
line(bbx, bby+wide_thickness/2, bbx, bby);
// 1/4
line(bbx,bby-edge/4, bbx+narrow_thickness/2, bby-edge/4);
line(bbx+narrow_thickness/2, bby-edge/4, bbx+narrow_thickness/2, bby-edge/2);
line(bbx+narrow_thickness/2, bby-edge/2, bbx+edge/2, bby-edge/2);
line(bbx+edge/2, bby-edge/2, bbx+edge/2, bby-narrow_thickness/2);
line(bbx+edge/2, bby-narrow_thickness/2, bbx+edge/4, bby-narrow_thickness/2);
line(bbx+edge/4, bby-narrow_thickness/2, bbx+edge/4, bby);
// 1/4
line(bbx,bby+edge/4, bbx+narrow_thickness/2, bby+edge/4);
line(bbx+narrow_thickness/2, bby+edge/4, bbx+narrow_thickness/2, bby+edge/2);
line(bbx+narrow_thickness/2, bby+edge/2, bbx+edge/2, bby+edge/2);
line(bbx+edge/2, bby+edge/2, bbx+edge/2, bby+narrow_thickness/2);
line(bbx+edge/2, bby+narrow_thickness/2,bbx+edge/4, bby+narrow_thickness/2);
line(bbx+edge/4, bby+narrow_thickness/2, bbx+edge/4, bby);


// Shape-C
// 1/4
// line(cx,cy-edge/4, cx-narrow_thickness/2, cy-edge/4);
// line(cx-narrow_thickness/2, cy-edge/4, cx-narrow_thickness/2, cy-edge/2);
// line(cx-narrow_thickness/2, cy-edge/2, cx-edge/2, cy-edge/2);
// line(cx-edge/2, cy-edge/2, cx-edge/2, cy-narrow_thickness/2);
// line(cx-edge/2, cy-narrow_thickness/2, cx-edge/4, cy-narrow_thickness/2);
// line(cx-edge/4, cy-narrow_thickness/2, cx-edge/4, cy);
// 1/4
// line(cx, cy+edge/4, cx-narrow_thickness/2, cy+edge/4);
// line(cx-narrow_thickness/2, cy+edge/4, cx-narrow_thickness/2, cy+edge/2);
// line(cx-narrow_thickness/2, cy+edge/2, cx-edge/2, cy+edge/2);
// line(cx-edge/2, cy+edge/2, cx-edge/2, cy+narrow_thickness/2);
// line(cx-edge/2, cy+narrow_thickness/2, cx-edge/4, cy+narrow_thickness/2);
// line(cx-edge/4, cy+narrow_thickness/2, cx-edge/4, cy);
// 1/4
// line(cx, cy-edge/4, cx+narrow_thickness/2, cy-edge/4);
// line(cx+narrow_thickness/2, cy-edge/4, cx+narrow_thickness/2, cy-edge/2);
// line(cx+narrow_thickness/2, cy-edge/2, cx+edge/2, cy-edge/2);
// 1/4
// line(cx, cy+edge/4, cx+narrow_thickness/2, cy+edge/4);
// line(cx+narrow_thickness/2, cy+edge/4, cx+narrow_thickness/2, cy+edge/2);
//line(cx+narrow_thickness/2, cy+edge/2, cx+edge/2, cy+edge/2);

//dx= cx+ edge;

// 1/4
//line(dx,dy-edge/4, dx-narrow_thickness/2, dy-edge/4);
//line(dx-narrow_thickness/2, dy-edge/4, dx-narrow_thickness/2, dy-edge/2);
//line(dx-narrow_thickness/2, dy-edge/2, dx-edge/2, dy-edge/2);

// 1/4
//line(dx,dy+edge/4, dx-narrow_thickness/2, dy+edge/4);
//line(dx-narrow_thickness/2, dy+edge/4, dx-narrow_thickness/2, dy+edge/2);
//line(dx-narrow_thickness/2, dy+edge/2, dx-edge/2, dy+edge/2);

// 1/4
//line(dx,dy-edge/4, dx+narrow_thickness/2, dy-edge/4);
//line(dx+narrow_thickness/2, dy-edge/4, dx+narrow_thickness/2, dy-edge/2);
//line(dx+narrow_thickness/2, dy-edge/2, dx+edge/2, dy-edge/2);
//line(dx+edge/2, dy-edge/2, dx+edge/2, dy-narrow_thickness/2);
//line(dx+edge/2, dy-narrow_thickness/2, dx+edge/4, dy-narrow_thickness/2);
//line(dx+edge/4, dy-narrow_thickness/2, dx+edge/4, dy);
// 1/4
//line(dx,dy+edge/4, dx+narrow_thickness/2, dy+edge/4);
//line(dx+narrow_thickness/2, dy+edge/4, dx+narrow_thickness/2, dy+edge/2);
//line(dx+narrow_thickness/2, dy+edge/2, dx+edge/2, dy+edge/2);
//line(dx+edge/2, dy+edge/2, dx+edge/2, dy+narrow_thickness/2);
//line(dx+edge/2, dy+narrow_thickness/2, dx+edge/4, dy+narrow_thickness/2);
//line(dx+edge/4, dy+narrow_thickness/2, dx+edge/4, dy);

////////////////////////////////////////////////////////////////////////////

// Circles

// Shape-A-1
// 1/4
line(ex,ey-edge/4, ex-narrow_thickness/2, ey-edge/4);
line(ex-narrow_thickness/2, ey-edge/4, ex-narrow_thickness/2, ey-edge/2);
arc(ex,ey,edge,edge,PI+atan(narrow_thickness/edge),3*PI/2-atan(narrow_thickness/edge));
line(ex-edge/2, ey-narrow_thickness/2, ex-edge/4, ey-narrow_thickness/2);
line(ex-edge/4, ey-narrow_thickness/2, ex-edge/4, ey);
// 1/4
line(ex,ey+edge/4,   ex-narrow_thickness/2, ey+edge/4);
line(ex-narrow_thickness/2, ey+edge/4, ex-narrow_thickness/2, ey+edge/2);
arc(ex,ey,edge,edge,PI/2+atan(narrow_thickness/edge),PI-atan(narrow_thickness/edge));
line(ex-edge/2, ey+narrow_thickness/2, ex-edge/4, ey+narrow_thickness/2);
line(ex-edge/4, ey+narrow_thickness/2, ex-edge/4, ey);
// 1/4
line(ex,ey-edge/4, ex+narrow_thickness/2, ey-edge/4);
line(ex+narrow_thickness/2, ey-edge/4, ex+narrow_thickness/2, ey-edge/2);
arc(ex,ey,edge,edge,3*PI/2+atan(narrow_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(ex+edge/2, ey-narrow_thickness/2, ex+edge/4, ey-narrow_thickness/2);
line(ex+edge/4, ey-narrow_thickness/2, ex+edge/4, ey);
// 1/4
line(ex, ey+edge/4, ex+narrow_thickness/2, ey+edge/4);
line(ex+narrow_thickness/2, ey+edge/4, ex+narrow_thickness/2, ey+edge/2);
arc(ex,ey,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(narrow_thickness/edge));
line(ex+edge/2, ey+narrow_thickness/2, ex+edge/4, ey+narrow_thickness/2);
line(ex+edge/4, ey+narrow_thickness/2, ex+edge/4, ey);

// Shape-A-2
// 1/4
line(eex,eey-edge/4, eex-wide_thickness/2, eey-edge/4);
line(eex-wide_thickness/2, eey-edge/4, eex-wide_thickness/2, eey-edge/2);
arc(eex,eey,edge,edge,PI+atan(narrow_thickness/edge),3*PI/2-atan(wide_thickness/edge));
line(eex-edge/2, eey-narrow_thickness/2, eex-edge/4, eey-narrow_thickness/2);
line(eex-edge/4, eey-narrow_thickness/2, eex-edge/4, eey);
// 1/4
line(eex,eey+edge/4,   eex-narrow_thickness/2, eey+edge/4);
line(eex-narrow_thickness/2, eey+edge/4, eex-narrow_thickness/2, eey+edge/2);
arc(eex,eey,edge,edge,PI/2+atan(narrow_thickness/edge),PI-atan(narrow_thickness/edge));
line(eex-edge/2, eey+narrow_thickness/2, eex-edge/4, eey+narrow_thickness/2);
line(eex-edge/4, eey+narrow_thickness/2, eex-edge/4, eey);
// 1/4
line(eex,eey-edge/4, eex+wide_thickness/2, eey-edge/4);
line(eex+wide_thickness/2, eey-edge/4, eex+wide_thickness/2, eey-edge/2);
arc(eex,eey,edge,edge,3*PI/2+atan(wide_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(eex+edge/2, eey-narrow_thickness/2, eex+edge/4, eey-narrow_thickness/2);
line(eex+edge/4, eey-narrow_thickness/2, eex+edge/4, eey);
// 1/4
line(eex, eey+edge/4, eex+narrow_thickness/2, eey+edge/4);
line(eex+narrow_thickness/2, eey+edge/4, eex+narrow_thickness/2, eey+edge/2);
arc(eex,eey,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(narrow_thickness/edge));
line(eex+edge/2, eey+narrow_thickness/2, eex+edge/4, eey+narrow_thickness/2);
line(eex+edge/4, eey+narrow_thickness/2, eex+edge/4, eey);


// Shape-A-3
// 1/4
line(eeex,eeey-edge/4, eeex-wide_thickness/2, eeey-edge/4);
line(eeex-wide_thickness/2, eeey-edge/4, eeex-wide_thickness/2, eeey-edge/2);
arc(eeex,eeey,edge,edge,PI+atan(wide_thickness/edge),3*PI/2-atan(wide_thickness/edge));
line(eeex-edge/2, eeey-wide_thickness/2, eeex-edge/4, eeey-wide_thickness/2);
line(eeex-edge/4, eeey-wide_thickness/2, eeex-edge/4, eeey);
// 1/4
line(eeex,eeey+edge/4,   eeex-narrow_thickness/2, eeey+edge/4);
line(eeex-narrow_thickness/2, eeey+edge/4, eeex-narrow_thickness/2, eeey+edge/2);
arc(eeex,eeey,edge,edge,PI/2+atan(narrow_thickness/edge),PI-atan(wide_thickness/edge));
line(eeex-edge/2, eeey+wide_thickness/2, eeex-edge/4, eeey+wide_thickness/2);
line(eeex-edge/4, eeey+wide_thickness/2, eeex-edge/4, eeey);
// 1/4
line(eeex,eeey-edge/4, eeex+wide_thickness/2, eeey-edge/4);
line(eeex+wide_thickness/2, eeey-edge/4, eeex+wide_thickness/2, eeey-edge/2);
arc(eeex,eeey,edge,edge,3*PI/2+atan(wide_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(eeex+edge/2, eeey-narrow_thickness/2, eeex+edge/4, eeey-narrow_thickness/2);
line(eeex+edge/4, eeey-narrow_thickness/2, eeex+edge/4, eeey);
// 1/4
line(eeex, eeey+edge/4, eeex+narrow_thickness/2, eeey+edge/4);
line(eeex+narrow_thickness/2, eeey+edge/4, eeex+narrow_thickness/2, eeey+edge/2);
arc(eeex,eeey,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(narrow_thickness/edge));
line(eeex+edge/2, eeey+narrow_thickness/2, eeex+edge/4, eeey+narrow_thickness/2);
line(eeex+edge/4, eeey+narrow_thickness/2, eeex+edge/4, eeey);


// Shape-A-4
// 1/4
line(eeeex,eeeey-edge/4, eeeex-wide_thickness/2, eeeey-edge/4);
line(eeeex-wide_thickness/2, eeeey-edge/4, eeeex-wide_thickness/2, eeeey-edge/2);
arc(eeeex,eeeey,edge,edge,PI+atan(wide_thickness/edge),3*PI/2-atan(wide_thickness/edge));
line(eeeex-edge/2, eeeey-wide_thickness/2, eeeex-edge/4, eeeey-wide_thickness/2);
line(eeeex-edge/4, eeeey-wide_thickness/2, eeeex-edge/4, eeeey);
// 1/4
line(eeeex,eeeey+edge/4,   eeeex-wide_thickness/2, eeeey+edge/4);
line(eeeex-wide_thickness/2, eeeey+edge/4, eeeex-wide_thickness/2, eeeey+edge/2);
arc(eeeex,eeeey,edge,edge,PI/2+atan(wide_thickness/edge),PI-atan(wide_thickness/edge));
line(eeeex-edge/2, eeeey+wide_thickness/2, eeeex-edge/4, eeeey+wide_thickness/2);
line(eeeex-edge/4, eeeey+wide_thickness/2, eeeex-edge/4, eeeey);
// 1/4
line(eeeex,eeeey-edge/4, eeeex+wide_thickness/2, eeeey-edge/4);
line(eeeex+wide_thickness/2, eeeey-edge/4, eeeex+wide_thickness/2, eeeey-edge/2);
arc(eeeex,eeeey,edge,edge,3*PI/2+atan(wide_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(eeeex+edge/2, eeeey-narrow_thickness/2, eeeex+edge/4, eeeey-narrow_thickness/2);
line(eeeex+edge/4, eeeey-narrow_thickness/2, eeeex+edge/4, eeeey);
// 1/4
line(eeeex, eeeey+edge/4, eeeex+wide_thickness/2, eeeey+edge/4);
line(eeeex+wide_thickness/2, eeeey+edge/4, eeeex+wide_thickness/2, eeeey+edge/2);
arc(eeeex,eeeey,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(wide_thickness/edge));
line(eeeex+edge/2, eeeey+narrow_thickness/2, eeeex+edge/4, eeeey+narrow_thickness/2);
line(eeeex+edge/4, eeeey+narrow_thickness/2, eeeex+edge/4, eeeey);

// Shape-A-5
// 1/4
line(eeeeex,eeeeey-edge/4, eeeeex-wide_thickness/2, eeeeey-edge/4);
line(eeeeex-wide_thickness/2, eeeeey-edge/4, eeeeex-wide_thickness/2, eeeeey-edge/2);
arc(eeeeex,eeeeey,edge,edge,PI+atan(narrow_thickness/edge),3*PI/2-atan(wide_thickness/edge));
line(eeeeex-edge/2, eeeeey-narrow_thickness/2, eeeeex-edge/4, eeeeey-narrow_thickness/2);
line(eeeeex-edge/4, eeeeey-narrow_thickness/2, eeeeex-edge/4, eeeeey);
// 1/4
line(eeeeex,eeeeey+edge/4,   eeeeex-wide_thickness/2, eeeeey+edge/4);
line(eeeeex-wide_thickness/2, eeeeey+edge/4, eeeeex-wide_thickness/2, eeeeey+edge/2);
arc(eeeeex,eeeeey,edge,edge,PI/2+atan(wide_thickness/edge),PI-atan(narrow_thickness/edge));
line(eeeeex-edge/2, eeeeey+narrow_thickness/2, eeeeex-edge/4, eeeeey+narrow_thickness/2);
line(eeeeex-edge/4, eeeeey+narrow_thickness/2, eeeeex-edge/4, eeeeey);
// 1/4
line(eeeeex,eeeeey-edge/4, eeeeex+wide_thickness/2, eeeeey-edge/4);
line(eeeeex+wide_thickness/2, eeeeey-edge/4, eeeeex+wide_thickness/2, eeeeey-edge/2);
arc(eeeeex,eeeeey,edge,edge,3*PI/2+atan(wide_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(eeeeex+edge/2, eeeeey-narrow_thickness/2, eeeeex+edge/4, eeeeey-narrow_thickness/2);
line(eeeeex+edge/4, eeeeey-narrow_thickness/2, eeeeex+edge/4, eeeeey);
// 1/4
line(eeeeex, eeeeey+edge/4, eeeeex+wide_thickness/2, eeeeey+edge/4);
line(eeeeex+wide_thickness/2, eeeeey+edge/4, eeeeex+wide_thickness/2, eeeeey+edge/2);
arc(eeeeex,eeeeey,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(wide_thickness/edge));
line(eeeeex+edge/2, eeeeey+narrow_thickness/2, eeeeex+edge/4, eeeeey+narrow_thickness/2);
line(eeeeex+edge/4, eeeeey+narrow_thickness/2, eeeeex+edge/4, eeeeey);

// Shape-A-6
// 1/4
line(eeeeeex,eeeeeey-edge/4, eeeeeex-wide_thickness/2, eeeeeey-edge/4);
line(eeeeeex-wide_thickness/2, eeeeeey-edge/4, eeeeeex-wide_thickness/2, eeeeeey-edge/2);
arc(eeeeeex,eeeeeey,edge,edge,PI+atan(wide_thickness/edge),3*PI/2-atan(wide_thickness/edge));
line(eeeeeex-edge/2, eeeeeey-wide_thickness/2, eeeeeex-edge/4, eeeeeey-wide_thickness/2);
line(eeeeeex-edge/4, eeeeeey-wide_thickness/2, eeeeeex-edge/4, eeeeeey);
// 1/4
line(eeeeeex,eeeeeey+edge/4,   eeeeeex-wide_thickness/2, eeeeeey+edge/4);
line(eeeeeex-wide_thickness/2, eeeeeey+edge/4, eeeeeex-wide_thickness/2, eeeeeey+edge/2);
arc(eeeeeex,eeeeeey,edge,edge,PI/2+atan(wide_thickness/edge),PI-atan(wide_thickness/edge));
line(eeeeeex-edge/2, eeeeeey+wide_thickness/2, eeeeeex-edge/4, eeeeeey+wide_thickness/2);
line(eeeeeex-edge/4, eeeeeey+wide_thickness/2, eeeeeex-edge/4, eeeeeey);
// 1/4
line(eeeeeex,eeeeeey-edge/4, eeeeeex+wide_thickness/2, eeeeeey-edge/4);
line(eeeeeex+wide_thickness/2, eeeeeey-edge/4, eeeeeex+wide_thickness/2, eeeeeey-edge/2);
arc(eeeeeex,eeeeeey,edge,edge,3*PI/2+atan(wide_thickness/edge),2*PI-atan(wide_thickness/edge));
line(eeeeeex+edge/2, eeeeeey-wide_thickness/2, eeeeeex+edge/4, eeeeeey-wide_thickness/2);
line(eeeeeex+edge/4, eeeeeey-wide_thickness/2, eeeeeex+edge/4, eeeeeey);
// 1/4
line(eeeeeex, eeeeeey+edge/4, eeeeeex+wide_thickness/2, eeeeeey+edge/4);
line(eeeeeex+wide_thickness/2, eeeeeey+edge/4, eeeeeex+wide_thickness/2, eeeeeey+edge/2);
arc(eeeeeex,eeeeeey,edge,edge,0+atan(wide_thickness/edge),PI/2-atan(wide_thickness/edge));
line(eeeeeex+edge/2, eeeeeey+wide_thickness/2, eeeeeex+edge/4, eeeeeey+wide_thickness/2);
line(eeeeeex+edge/4, eeeeeey+wide_thickness/2, eeeeeex+edge/4, eeeeeey);

// Shape-B
// 1/4
line(fx,fy-edge/4, fx-narrow_thickness/2, fy-edge/4);
line(fx-narrow_thickness/2, fy-edge/4, fx-narrow_thickness/2, fy-edge/2);
arc(fx,fy,edge,edge,PI+atan(narrow_thickness/edge),3*PI/2-atan(narrow_thickness/edge));
line(fx-edge/2, fy-narrow_thickness/2, fx, fy-narrow_thickness/2);
line(fx, fy-narrow_thickness/2, fx, fy);
// 1/4
line(fx,fy+edge/4, fx-narrow_thickness/2, fy+edge/4);
line(fx-narrow_thickness/2, fy+edge/4, fx-narrow_thickness/2, fy+edge/2);
arc(fx,fy,edge,edge,PI/2+atan(narrow_thickness/edge),PI-atan(narrow_thickness/edge));
line(fx-edge/2, fy+narrow_thickness/2, fx, fy+narrow_thickness/2);
line(fx, fy+narrow_thickness/2, fx, fy);
// 1/4
line(fx,fy-edge/4, fx+narrow_thickness/2, fy-edge/4);
line(fx+narrow_thickness/2, fy-edge/4, fx+narrow_thickness/2, fy-edge/2);
arc(fx,fy,edge,edge,3*PI/2+atan(narrow_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(fx+edge/2, fy-narrow_thickness/2, fx+edge/4, fy-narrow_thickness/2);
line(fx+edge/4, fy-narrow_thickness/2, fx+edge/4, fy);
// 1/4
line(fx, fy+edge/4, fx+narrow_thickness/2, fy+edge/4);
line(fx+narrow_thickness/2, fy+edge/4, fx+narrow_thickness/2, fy+edge/2);
arc(fx,fy,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(narrow_thickness/edge));
line(fx+edge/2, fy+narrow_thickness/2, fx+edge/4, fy+narrow_thickness/2);
line(fx+edge/4, fy+narrow_thickness/2, fx+edge/4, fy);


// Shape-B
// 1/4
line(ffx,ffy-edge/4, ffx-narrow_thickness/2, ffy-edge/4);
line(ffx-narrow_thickness/2, ffy-edge/4, ffx-narrow_thickness/2, ffy-edge/2);
arc(ffx,ffy,edge,edge,PI+atan(wide_thickness/edge),3*PI/2-atan(narrow_thickness/edge));
line(ffx-edge/2, ffy-wide_thickness/2, ffx, ffy-wide_thickness/2);
line(ffx, ffy-wide_thickness/2, ffx, ffy);
// 1/4
line(ffx,ffy+edge/4, ffx-narrow_thickness/2, ffy+edge/4);
line(ffx-narrow_thickness/2, ffy+edge/4, ffx-narrow_thickness/2, ffy+edge/2);
arc(ffx,ffy,edge,edge,PI/2+atan(narrow_thickness/edge),PI-atan(wide_thickness/edge));
line(ffx-edge/2, ffy+wide_thickness/2, ffx, ffy+wide_thickness/2);
line(ffx, ffy+wide_thickness/2, ffx, ffy);
// 1/4
line(ffx,ffy-edge/4, ffx+narrow_thickness/2, ffy-edge/4);
line(ffx+narrow_thickness/2, ffy-edge/4, ffx+narrow_thickness/2, ffy-edge/2);
arc(ffx,ffy,edge,edge,3*PI/2+atan(narrow_thickness/edge),2*PI-atan(narrow_thickness/edge));
line(ffx+edge/2, ffy-narrow_thickness/2, ffx+edge/4, ffy-narrow_thickness/2);
line(ffx+edge/4, ffy-narrow_thickness/2, ffx+edge/4, ffy);
// 1/4
line(ffx, ffy+edge/4, ffx+narrow_thickness/2, ffy+edge/4);
line(ffx+narrow_thickness/2, ffy+edge/4, ffx+narrow_thickness/2, ffy+edge/2);
arc(ffx,ffy,edge,edge,0+atan(narrow_thickness/edge),PI/2-atan(narrow_thickness/edge));
line(ffx+edge/2, ffy+narrow_thickness/2, ffx+edge/4, ffy+narrow_thickness/2);
line(ffx+edge/4, ffy+narrow_thickness/2, ffx+edge/4, ffy);


////////////////////////////////////////////////////////////////////////////

// Triangles

/// a - 1
line(ix+cos(PI*5/6)*edge/4,iy-sin(PI*5/6)*edge/4,ix+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2);
line(ix+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2,ix+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2);
line(ix+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2,ix+cos(PI*7/6)*edge, iy-sin(PI*7/6)*edge);
line(ix+cos(PI*7/6)*edge, iy-sin(PI*7/6)*edge, ix+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(ix+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,ix+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(ix+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,ix+cos(PI*9/6)*edge/4,iy-sin(PI*9/6)*edge/4);


line(ix+cos(PI*1/6)*edge/4,iy-sin(PI*1/6)*edge/4,ix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2);
line(ix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2,ix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2);
line(ix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2,ix+cos(PI*11/6)*edge, iy-sin(PI*11/6)*edge);
line(ix+cos(PI*11/6)*edge, iy-sin(PI*11/6)*edge, ix-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(ix-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,ix-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(ix-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,iy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,ix-cos(PI*9/6)*edge/4,iy-sin(PI*9/6)*edge/4);

line(ix+cos(PI*5/6)*edge/4,iy-sin(PI*5/6)*edge/4,ix+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(ix+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,ix+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(ix+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,ix+cos(PI*1/2)*edge, iy-sin(PI*1/2)*edge);
line(ix-cos(PI*5/6)*edge/4,iy-sin(PI*5/6)*edge/4,ix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(ix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,ix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(ix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,ix-cos(PI*1/2)*edge, iy-sin(PI*1/2)*edge);


// Triangles

/// a - 2
line(iix+cos(PI*5/6)*edge/4,iiy-sin(PI*5/6)*edge/4,iix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2);
line(iix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2,iix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2);
line(iix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2,iix+cos(PI*7/6)*edge, iiy-sin(PI*7/6)*edge);
line(iix+cos(PI*7/6)*edge, iiy-sin(PI*7/6)*edge, iix+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(iix+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,iix+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(iix+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,iix+cos(PI*9/6)*edge/4,iiy-sin(PI*9/6)*edge/4);


line(iix+cos(PI*1/6)*edge/4,iiy-sin(PI*1/6)*edge/4,iix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2);
line(iix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2,iix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2);
line(iix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2,iix+cos(PI*11/6)*edge, iiy-sin(PI*11/6)*edge);
line(iix+cos(PI*11/6)*edge, iiy-sin(PI*11/6)*edge, iix-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(iix-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,iix-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(iix-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,iiy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,iix-cos(PI*9/6)*edge/4,iiy-sin(PI*9/6)*edge/4);

line(iix+cos(PI*5/6)*edge/4,iiy-sin(PI*5/6)*edge/4,iix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2);
line(iix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2,iix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2);
line(iix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2,iix+cos(PI*1/2)*edge, iiy-sin(PI*1/2)*edge);
line(iix-cos(PI*5/6)*edge/4,iiy-sin(PI*5/6)*edge/4,iix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(iix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,iix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(iix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,iix-cos(PI*1/2)*edge, iiy-sin(PI*1/2)*edge);

// Triangles

/// a - 3
line(iiix+cos(PI*5/6)*edge/4,iiiy-sin(PI*5/6)*edge/4,iiix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2);
line(iiix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2,iiix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2);
line(iiix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2,iiix+cos(PI*7/6)*edge, iiiy-sin(PI*7/6)*edge);
line(iiix+cos(PI*7/6)*edge, iiiy-sin(PI*7/6)*edge, iiix+cos(PI*9/6)*edge/2+cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2);
line(iiix+cos(PI*9/6)*edge/2+cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2,iiix+cos(PI*9/6)*edge/4+cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2);
line(iiix+cos(PI*9/6)*edge/4+cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2,iiix+cos(PI*9/6)*edge/4,iiiy-sin(PI*9/6)*edge/4);


line(iiix+cos(PI*1/6)*edge/4,iiiy-sin(PI*1/6)*edge/4,iiix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iiiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2);
line(iiix+cos(PI*1/6)*edge/4+cos(PI*10/6)*narrow_thickness/2,iiiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*narrow_thickness/2,iiix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iiiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2);
line(iiix+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,iiiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2,iiix+cos(PI*11/6)*edge, iiiy-sin(PI*11/6)*edge);
line(iiix+cos(PI*11/6)*edge, iiiy-sin(PI*11/6)*edge, iiix-cos(PI*9/6)*edge/2-cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2);
line(iiix-cos(PI*9/6)*edge/2-cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2,iiix-cos(PI*9/6)*edge/4-cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2);
line(iiix-cos(PI*9/6)*edge/4-cos(PI)*wide_thickness/2,iiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2,iiix-cos(PI*9/6)*edge/4,iiiy-sin(PI*9/6)*edge/4);

line(iiix+cos(PI*5/6)*edge/4,iiiy-sin(PI*5/6)*edge/4,iiix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2);
line(iiix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2,iiix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2);
line(iiix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2,iiix+cos(PI*1/2)*edge, iiiy-sin(PI*1/2)*edge);
line(iiix-cos(PI*5/6)*edge/4,iiiy-sin(PI*5/6)*edge/4,iiix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(iiix-cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,iiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,iiix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(iiix-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,iiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,iiix-cos(PI*1/2)*edge, iiiy-sin(PI*1/2)*edge);


/// a - 4
line(iiiix+cos(PI*5/6)*edge/4,iiiiy-sin(PI*5/6)*edge/4,iiiix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2);
line(iiiix+cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4-sin(PI*4/3)*wide_thickness/2,iiiix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2);
line(iiiix+cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2-sin(PI*4/3)*wide_thickness/2,iiiix+cos(PI*7/6)*edge, iiiiy-sin(PI*7/6)*edge);
line(iiiix+cos(PI*7/6)*edge, iiiiy-sin(PI*7/6)*edge, iiiix+cos(PI*9/6)*edge/2+cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2);
line(iiiix+cos(PI*9/6)*edge/2+cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2,iiiix+cos(PI*9/6)*edge/4+cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2);
line(iiiix+cos(PI*9/6)*edge/4+cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2,iiiix+cos(PI*9/6)*edge/4,iiiiy-sin(PI*9/6)*edge/4);


line(iiiix+cos(PI*1/6)*edge/4,iiiiy-sin(PI*1/6)*edge/4,iiiix+cos(PI*1/6)*edge/4+cos(PI*10/6)*wide_thickness/2,iiiiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*wide_thickness/2);
line(iiiix+cos(PI*1/6)*edge/4+cos(PI*10/6)*wide_thickness/2,iiiiy-sin(PI*1/6)*edge/4-sin(PI*10/6)*wide_thickness/2,iiiix+cos(PI*1/6)*edge/2+cos(PI*10/6)*wide_thickness/2,iiiiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*wide_thickness/2);
line(iiiix+cos(PI*1/6)*edge/2+cos(PI*10/6)*wide_thickness/2,iiiiy-sin(PI*1/6)*edge/2-sin(PI*10/6)*wide_thickness/2,iiiix+cos(PI*11/6)*edge, iiiiy-sin(PI*11/6)*edge);
line(iiiix+cos(PI*11/6)*edge, iiiiy-sin(PI*11/6)*edge, iiiix-cos(PI*9/6)*edge/2-cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2);
line(iiiix-cos(PI*9/6)*edge/2-cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/2-sin(PI)*wide_thickness/2,iiiix-cos(PI*9/6)*edge/4-cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2);
line(iiiix-cos(PI*9/6)*edge/4-cos(PI)*wide_thickness/2,iiiiy-sin(PI*9/6)*edge/4-sin(PI)*wide_thickness/2,iiiix-cos(PI*9/6)*edge/4,iiiiy-sin(PI*9/6)*edge/4);

line(iiiix+cos(PI*5/6)*edge/4,iiiiy-sin(PI*5/6)*edge/4,iiiix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2);
line(iiiix+cos(PI*5/6)*edge/4-cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2,iiiix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2);
line(iiiix+cos(PI*5/6)*edge/2-cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2,iiiix+cos(PI*1/2)*edge, iiiiy-sin(PI*1/2)*edge);
line(iiiix-cos(PI*5/6)*edge/4,iiiiy-sin(PI*5/6)*edge/4,iiiix-cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2);
line(iiiix-cos(PI*5/6)*edge/4+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/4+sin(PI*4/3)*wide_thickness/2,iiiix-cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2);
line(iiiix-cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,iiiiy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2,iiiix-cos(PI*1/2)*edge, iiiiy-sin(PI*1/2)*edge);

/// b - 1
line(jx+cos(PI*5/6)*edge/4,jy-sin(PI*5/6)*edge/4,jx+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2);
line(jx+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2,jx+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2);
line(jx+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2,jx+cos(PI*7/6)*edge, jy-sin(PI*7/6)*edge);
line(jx+cos(PI*7/6)*edge, jy-sin(PI*7/6)*edge, jx+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(jx+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,jx+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(jx+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,jx+cos(PI*9/6)*edge/4,jy-sin(PI*9/6)*edge/4);


line(jx,jy,jx+cos(PI*10/6)*narrow_thickness/2,jy-sin(PI*10/6)*narrow_thickness/2);
line(jx+cos(PI*10/6)*narrow_thickness/2,jy-sin(PI*10/6)*narrow_thickness/2,jx+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,jy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2);
line(jx+cos(PI*1/6)*edge/2+cos(PI*10/6)*narrow_thickness/2,jy-sin(PI*1/6)*edge/2-sin(PI*10/6)*narrow_thickness/2,jx+cos(PI*11/6)*edge, jy-sin(PI*11/6)*edge);
line(jx+cos(PI*11/6)*edge, jy-sin(PI*11/6)*edge, jx-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(jx-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,jx-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(jx-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,jy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,jx-cos(PI*9/6)*edge/4,jy-sin(PI*9/6)*edge/4);

line(jx+cos(PI*5/6)*edge/4,jy-sin(PI*5/6)*edge/4,jx+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(jx+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,jx+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(jx+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,jx+cos(PI*1/2)*edge, jy-sin(PI*1/2)*edge);
line(jx,jy,jx+cos(PI*4/3)*narrow_thickness/2,jy+sin(PI*4/3)*narrow_thickness/2);
line(jx+cos(PI*4/3)*narrow_thickness/2,jy+sin(PI*4/3)*narrow_thickness/2,jx-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(jx-cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,jx-cos(PI*1/2)*edge, jy-sin(PI*1/2)*edge);

/// b -2
line(jjx+cos(PI*5/6)*edge/4,jjy-sin(PI*5/6)*edge/4,jjx+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2);
line(jjx+cos(PI*5/6)*edge/4+cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/4-sin(PI*4/3)*narrow_thickness/2,jjx+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2);
line(jjx+cos(PI*5/6)*edge/2+cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/2-sin(PI*4/3)*narrow_thickness/2,jjx+cos(PI*7/6)*edge, jjy-sin(PI*7/6)*edge);
line(jjx+cos(PI*7/6)*edge, jjy-sin(PI*7/6)*edge, jjx+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(jjx+cos(PI*9/6)*edge/2+cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,jjx+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(jjx+cos(PI*9/6)*edge/4+cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,jjx+cos(PI*9/6)*edge/4,jjy-sin(PI*9/6)*edge/4);


line(jjx,jjy,jjx+cos(PI*10/6)*wide_thickness/2,jjy-sin(PI*10/6)*wide_thickness/2);
line(jjx+cos(PI*10/6)*wide_thickness/2,jjy-sin(PI*10/6)*wide_thickness/2,jjx+cos(PI*1/6)*edge/2+cos(PI*10/6)*wide_thickness/2,jjy-sin(PI*1/6)*edge/2-sin(PI*10/6)*wide_thickness/2);
line(jjx+cos(PI*1/6)*edge/2+cos(PI*10/6)*wide_thickness/2,jjy-sin(PI*1/6)*edge/2-sin(PI*10/6)*wide_thickness/2,jjx+cos(PI*11/6)*edge, jjy-sin(PI*11/6)*edge);
line(jjx+cos(PI*11/6)*edge, jjy-sin(PI*11/6)*edge, jjx-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2);
line(jjx-cos(PI*9/6)*edge/2-cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/2-sin(PI)*narrow_thickness/2,jjx-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2);
line(jjx-cos(PI*9/6)*edge/4-cos(PI)*narrow_thickness/2,jjy-sin(PI*9/6)*edge/4-sin(PI)*narrow_thickness/2,jjx-cos(PI*9/6)*edge/4,jjy-sin(PI*9/6)*edge/4);

line(jjx+cos(PI*5/6)*edge/4,jjy-sin(PI*5/6)*edge/4,jjx+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2);
line(jjx+cos(PI*5/6)*edge/4-cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/4+sin(PI*4/3)*narrow_thickness/2,jjx+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2);
line(jjx+cos(PI*5/6)*edge/2-cos(PI*4/3)*narrow_thickness/2,jjy-sin(PI*5/6)*edge/2+sin(PI*4/3)*narrow_thickness/2,jjx+cos(PI*1/2)*edge, jjy-sin(PI*1/2)*edge);
line(jjx,jjy,jjx+cos(PI*4/3)*wide_thickness/2,jjy+sin(PI*4/3)*wide_thickness/2);
line(jjx+cos(PI*4/3)*wide_thickness/2,jjy+sin(PI*4/3)*wide_thickness/2,jjx-cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,jjy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2);
line(jjx-cos(PI*5/6)*edge/2+cos(PI*4/3)*wide_thickness/2,jjy-sin(PI*5/6)*edge/2+sin(PI*4/3)*wide_thickness/2,jjx-cos(PI*1/2)*edge, jjy-sin(PI*1/2)*edge);


 if (record) {
    endRecord();
    record = false;
      println("end");
  }

}


void keyPressed() {
  // use a key press so that it doesn't make a million files
  if (key == 'r') record = true;
}



